var BASE_PATH = 'http://jzzj.newborn-tech.com/';
var BASE_IMG_PATG = '';

var GET_API = {
    'getApi': function (url, par) {
        // loadingPlugin.add();
        par = par ? par : {};
        var token = getQueryString('access-token');
        var device = getQueryString('device');
        var basePar = {};
        var data = $.extend(true, par, basePar);
        var fullUrl = BASE_PATH + url;
        var settings = {
            type: "POST",
            url: fullUrl,
            data: data,
            headers: {
                'access-token': token,
                'device': device
            }
        };
        var promise = new Promise(function (resolve, reject) {
            $.ajax(settings).then(
                (res) => {
                    loadingPlugin.remove();
                    var status = res.status;
                    if (status === 0) {
                        resolve(res.data);
                    } else {
                        var message = res.message || '提交出错';
                        reject(message);
                        toastPlugin.add(message);
                        if (status === 206 || status === 207) {
                            // backAppFunc({
                            //     opentype: 0,
                            //     openurl: 'view/login'
                            // });
                        }
                    }
                },
                (err) => {
                    var message = err.message || '提交出错';
                    // loadingPlugin.remove();
                    reject(message);
                    toastPlugin.add(message);
                }
            );
        });
        return promise;
    },
    'articleCollection': function (par) { // 获取收藏文章
        var url = 'api/article/collection';
        return this.getApi(url, par);
    },
    'courseCollection': function (par) { // 获取收藏课程
        var url = 'api/course/collection';
        return this.getApi(url, par);
    },
    'courseLearnLog': function (par) { // 获取观看历史记录
        var url = 'api/course_learn/get';
        return this.getApi(url, par);
    },
    'apiOrderGet': function (par) { // 获取我的订单
        var url = 'api/order/lst';
        return this.getApi(url, par);
    },
    'apiMemberIndex': function (par) { // 获取会员中心数据
        var url = 'api/member/index';
        return this.getApi(url, par);
    },
    'apiMemberSign': function (par) { // 获取签到列表
        var url = 'api/member/signin_get';
        return this.getApi(url, par);
    },
    'apiMemberSignPut': function (par) { // 签到
        var url = 'api/member/signin_put';
        return this.getApi(url, par);
    },
    'apiCouponGet': function (par) { // 获取我的优惠券
        var url = 'api/coupon/get';
        return this.getApi(url, par);
    },
    'apiCourseNoteGet': function (par) { // 获取我的笔记
        var url = 'api/course_note/get';
        return this.getApi(url, par);
    },
    'apiCourseNoteDel': function (par) { // 删除我的笔记
        var url = 'api/course_note/del';
        return this.getApi(url, par);
    },
    'apiArticleFind': function (par) { // 获取文章详情
        var url = 'api/article/find';
        return this.getApi(url, par);
    },
    'apiCommentGet': function (par) { // 获取文章评论
        var url = 'api/comment/get';
        return this.getApi(url, par);
    },
    /**
     * 获取钱包记录
     * par: 参数
     * type: icon甲子币 fen积分 exp禁言
    * */
    'apiPaymentLog': function (par, type){
        var url = 'api/wallet/'+type
        return this.getApi(url, par);
    }
};