$(function () {

        function setHtml(item) {
            $(".article-top").css({"background-image": "url('" + item.image + "')"})
            $(".article-title").html(item.title);
            $(".article-author").html(item.author);
            $(".perview-qty").html(item.preview_qty);
            $(".comment-qty").html(item.comment_qty);
            $(".statistics-like-qty").html(item.like_qty);
            $(".article-create-time").html(getDateDiff(item.create_time));
            $(".article-detail-main").html(item.content);
            var tags = item.tags || [];
            if (tags.length > 0) {
                var tag = "";
                tags.forEach(item => {
                    tag += '<div class="article-tag-item">· ' + item + '</div>';
                })
                $(".article-tags-box").html(tag);
            }
        }

        function setMoreHtml(data) {
            var more = "";
            if (data.length > 0) {
                data.forEach(item => {
                    more += '<div class="article-more-item" data-id="' + item.id + '"><img src="' + item.image + '" alt=""></div>';
                })
                $(".article-more-list").html(more);
                $(".article-more-item").on("click", jumpArticlePage);
            } else {
                $(".article-more-box").css("display", "none")
            }
        }
        var jumpArticlePage = function (){
            var id = $(this).data('id');
            window.location.href = "/views/article.html?access-token="+getQueryString('access-token')+"&article_id="+id;
        }
        var getDateDiff = function (setdateTimeStamp) {
            var result = "";
            var minute = 1000 * 60;
            var hour = minute * 60;
            var day = hour * 24;
            var halfamonth = day * 15;
            var month = day * 30;
            var dateTimeStamp = new Date(setdateTimeStamp);
            var now = new Date().getTime();
            var diffValue = now - dateTimeStamp;
            if (diffValue < 0) {
                //若日期不符则弹出窗口告之
                return "结束日期不能小于开始日期！";
            }
            var monthC = diffValue / month;
            var weekC = diffValue / (7 * day);
            var dayC = diffValue / day;
            var hourC = diffValue / hour;
            var minC = diffValue / minute;
            if (monthC >= 1) {
                result = parseInt(monthC) + "个月前";
            } else if (weekC >= 1) {
                result = parseInt(weekC) + "周前";
            } else if (dayC >= 1) {
                result = parseInt(dayC) + "天前";
            } else if (hourC >= 1) {
                result = parseInt(hourC) + "个小时前";
            } else if (minC >= 1) {
                result = parseInt(minC) + "分钟前";
            } else
                result = "刚刚";
            return result;
        }

        function setCommentHtml(item){
            var comment =  '                <div class="article-comment-item">\n' +
                '                    <div class="article-comment-item-left">\n' +
                '                        <img class="head-img" src="'+item.avatar+'" alt="">\n' +
                '                    </div>\n' +
                '                    <div class="comment-item-right">\n' +
                '                        <div class="comment-item-right-top">\n' +
                '                            <span class="nickname">'+item.nickname+'</span>\n' +
                '                            <div class="like-box '+(item.is_like === 1 ? 'active' : '')+'">\n' +
                '                                <span class="select iconfont '+(item.is_like === 1 ? 'icon-xihuan1' : 'icon-xihuan')+'"></span>\n' +
                '                                <span class="like-qty">'+item.like_qty+'</span>\n' +
                '                            </div>\n' +
                '                        </div>\n' +
                '                        <div class="article-comment-content">'+item.desc+'</div>';
                if(item.comment_data){
                    comment +='                        <div class="article-reply-box">\n' +
                        '                            <span class="article-reply-member">'+item.reply_member_nickname+'：</span>\n' +
                        '                            <span class="article-reply-content">'+item.comment_data+'</span>\n' +
                        '                        </div>';
                }
                comment += '                    </div>\n' +
                '                </div>\n';
                return comment;
        }

        function getArticleFind() {
            var id = getQueryString('article_id');
            GET_API.apiArticleFind({id: id}).then(res => {
                setHtml(res);
                setMoreHtml(res.list || [])
            })
        }

        function commentGet() {
            var par = {type: "article", key_id: getQueryString('article_id')}
            GET_API.apiCommentGet(par).then(res => {
                var html = "";
                var list = res.data || [];
                if(list.length > 0){
                    list.forEach(item => {
                        html += setCommentHtml(item)
                    })
                }else{

                }
                $(".article-comment-list").html(html);
            })
        }
        getArticleFind();
        commentGet();
    }
)