$(function (){
    var article_limit = 10;
    var course_limit = 10;
    var index = 0;
    var $article = $("#article");
    var $course = $("#course");

    $(".collect-nav-item").on("click", function (){
        const $this = $(this);
        index= $this.index();
        $this.addClass('active').siblings().removeClass("active");
        $(".collect-content > div").eq(index).show().siblings().hide();
    })

    function articleCollectionGet(){
        GET_API.articleCollection({limit: article_limit}).then(res => {
            var html = "";
            if(res.length > 0){
                res.forEach(item => {
                    html += setHtml(item, "article");
                })
            }else{
                html = `<div class="no-data">
                           <img class="no-data-img" src="/static/images/no_collect_article.png" alt="">
                           <div class="no-data-btn">返回内容</div>
                        </div>`
            }
            $article.append(html);
        })
    }

    function courseCollectionGet(){
        GET_API.courseCollection({limit: course_limit}).then(res => {
            var html = "";
            if(res.length > 0){
                res.forEach(item => {
                    html += setHtml(item, "course");
                })
            }else {
                html = '<div class="no-data"><img class="no-data-img" src="/static/images/no_collect_course.png" alt=""><div class="no-data-btn">返回课程</div></div>';
            }
            $course.html(html);
        })
    }

    function setHtml(data, type){
        var res = "";
        if(type === "article"){
            res = '<li class="article-item">\n' +
                '                <div class="article-item-left">\n' +
                '                    <p class="article-title">'+data.article_title+'</p>\n' +
                '                    <div class="article-bottom-info">\n' +
                '                        <span class="article-category">'+data.category_name+'</span>\n' +
                '                        <span class="collect-time">'+getDateDiff(data.create_time)+'</span>\n' +
                '                    </div>\n' +
                '                </div>\n' +
                '                <div class="article-item-right" style="background-image: url('+data.article_image+')">\n' +
                '                    <div class="read-box">\n' +
                '                        <span class="iconfont read-icon">&#xe693;</span>\n' +
                '                        <span class="read-qty">'+data.preview_qty+'</span>\n' +
                '                    </div>\n' +
                '                </div>\n' +
                '            </li>';
        }else if(type === "course"){
            res = '<li class="article-item">\n' +
                '                <div class="article-item-left">\n' +
                '                    <p class="article-title">'+data.title+'</p>\n' +
                '                    <div class="article-bottom-info">\n' +
                '                        <span class="article-category">'+data.author+'</span>\n' +
                '                    </div>\n' +
                '                </div>\n' +
                '                <div class="article-item-right" style="background-image: url('+data.image+')">\n' +
                '                    <div class="read-box">\n' +
                '                        <span class="iconfont read-icon">&#xe693;</span>\n' +
                '                        <span class="read-qty">'+data.preview_qty+'</span>\n' +
                '                    </div>\n' +
                '                </div>\n' +
                '            </li>';
        }
        return res;
    }

    function getDateDiff(dateTimeStamp){
        dateTimeStamp = new Date(dateTimeStamp).getTime();
        var minute = 1000 * 60;
        var hour = minute * 60;
        var day = hour * 24;
        var halfamonth = day * 15;
        var month = day * 30;
        var now = new Date().getTime();
        var diffValue = now - dateTimeStamp;
        if(diffValue < 0){return;}
        var monthC =diffValue/month;
        var weekC =diffValue/(7*day);
        var dayC =diffValue/day;
        var hourC =diffValue/hour;
        var minC =diffValue/minute;
        var result = "";
        if(monthC>=1){
            result="" + parseInt(monthC) + "月前";
        }
        else if(weekC>=1){
            result="" + parseInt(weekC) + "周前";
        }
        else if(dayC>=1){
            result=""+ parseInt(dayC) +"天前";
        }
        else if(hourC>=1){
            result=""+ parseInt(hourC) +"小时前";
        }
        else if(minC>=1){
            result=""+ parseInt(minC) +"分钟前";
        }else
            result="刚刚";
        return result;
    }

    $(window).scroll(function(){
        var scrollTop = $(this).scrollTop();
        var scrollHeight = $(document).height();
        var windowHeight = $(this).height();
        if((scrollTop + windowHeight)+1 == scrollHeight){
            if(index === 0){
                article_limit += 10;
                articleCollectionGet();
            }else if(index === 1){
                course_limit += 10;
                courseCollectionGet();
            }
        }
    });
    articleCollectionGet();
    courseCollectionGet();
});