$(function () {
    var list = [];
    var limit = 10;
    var total = 0;
    var type = "";

    $(".order-nav-item").on('click', function () {
        var $this = $(this);
        $this.addClass("active").siblings().removeClass("active");
        if(type === $this.data("type")) return;
        type = $this.data("type");
        limit = 10;
        getData();
    })

    function typeFilter(type) {
        return type === 0 ? '余额' : type === 1 ? '微信' : type === 2 ? '支付宝' : '其他';
    }

    function setHtml(item) {
        // 0待支付 1支付完成 2退款 3删除
        var html = "";
        html += '<div class="order-item">\n' +
            '            <div class="order-item-top">\n' +
            '                <div class="order-number">订单号：' + item.order_id + '</div>'
        if(item.state === 0){
            html += '<div class="order-status">待支付</div>'
        }else if(item.state === 1 && item.is_gift === 0){
            html += '<div class="order-status order-status-1">消费成功</div>'
        }else if(item.state === 1 && item.is_gift !== 0){
            html += '<div class="order-status order-status-1">赠送成功</div>'
        }
        html += '            </div>\n' +
            '            <div class="order-item-center">\n' +
            '                <div class="order-item-center-left">'
        if (item.is_gift !== 0) {
            html += '<div class="order-item-pay-icon">礼物赠送</div>';
        } else {
            html += '<img style="width: 100%; height: 100%;" src="' + item.course_image + '" alt="">'
        }
        html += '                </div>\n' +
            '                <div class="order-item-center-right">\n' +
            '                    <div class="order-item-center-right-money">\n' +
            '                        <span class="order-item-key">甲子币：</span>\n' +
            '                        <span class="order-item-money-val">' + item.total + '个</span>\n' +
            '                    </div>\n' +
            '                    <div class="order-item-center-right-type">\n' +
            '                        <span class="order-item-key">支付方式：</span>\n' +
            '                        <span class="order-item-type-val">' + typeFilter(item.pay_type) + '</span>\n' +
            '                    </div>\n' +
            '                    <div class="order-item-center-right-time">\n' +
            '                        <span class="order-item-key">购买时间：</span>\n' +
            '                        <span class="order-item-time-val">' + item.create_time + '</span>\n' +
            '                    </div>\n' +
            '                </div>\n' +
            '            </div>\n' +
            '            <div class="order-item-bottom">\n' +
            '                <div class="order-detail-info">实付：' + item.pay_total + '甲子币</div>\n' +
            '                <div class="del-order-btn">删除订单</div>\n' +
            '            </div>\n' +
            '        </div>';

        return html;
    }

    $(window).scroll(function () {
        var scrollTop = $(this).scrollTop();
        var scrollHeight = $(document).height();
        var windowHeight = $(this).height();
        if ((scrollTop + windowHeight) + 1 == scrollHeight) {
            limit += 10;
            getData();
        }
    });


    function getData() {
        GET_API.apiOrderGet({type: type, limit: limit}).then(res => {
            var html = "";
            list = res.data;
            total = res.total;
            if (list.length > 0) {
                list.forEach(item => {
                    html += setHtml(item);
                })
            } else {
                html = '<div class="no-data"><img class="no-data-img" src="/static/images/no_order.png" alt=""></div>'
            }
            $(".order-content").html(html);
        })
    }
    getData();
})